#ifndef VIEW_H
#define VIEW_H

#include "data/Array.h"
#include "math/Matrix.h"
#include "math/Plane.h"
#include "math/Quaternion.h"

class View final {
    Matrix view;
    Vector3 right;
    Vector3 up;
    Vector3 back;

public:
    const Matrix& update(float lengthAngle, float widthAngle,
                         const Vector3& pos);
    const Matrix& update(const Quaternion& q, const Vector3& pos);

    Vector3 getUp() const;
    Vector3 getDown() const;
    Vector3 getLeft() const;
    Vector3 getRight() const;
    Vector3 getFront() const;
    Vector3 getBack() const;
};

#endif